# -*- coding: utf-8 -*-
"""
@author: spapadim
"""

import sys
from example2d import *
from matplotlib import animation
from sklearn.svm import SVC

features_n = (features - mean(features, axis=0)) / std(features, axis=0)

def gamma_animation(gammas, surface = False, interval = 250):
  global features_n, labels
  fig = figure()
  #fig.set_facecolor("white")
  ax = axes() if not surface else axes(projection='3d')
  def init():
    ax.clear()
    #ax.set_axis_off()
    ax.set_title("")
  def animate(gamma):
    print >>sys.stderr, "Frame: %6.2f" % gamma
    ax.clear()
    #ax.set_axis_off()
    svm = SVC(kernel='rbf', gamma=gamma)
    svm.fit(features_n, labels)
    if surface:
      plot_model2d(svm, features_n, value_func='decision_function', surface=True, ax=ax, cmap=cm.coolwarm, zlim=(-1.5,1.5))
    else:
      plot_fit2d(svm, features_n, labels, fig=fig)
    title("SVM (RBF); gamma=%6.2f" % gamma)
  anim = animation.FuncAnimation(
          fig, animate, init_func=init, frames=gammas,
          interval=interval, repeat=False) #, blit=True)
  return anim

gammas = exp(arange(-3,6,0.125))
writer = animation.AVConvWriter()

anim = gamma_animation(gammas)
anim.save('/tmp/gamma_contour.mp4', writer=writer, 
          extra_args=['-vcodec', 'libx264'])

anim = gamma_animation(gammas, surface=True)
anim.save('/tmp/gamma_surf.mp4', writer=writer, 
          extra_args=['-vcodec', 'libx264'])
